#include <iostream>
#include <vector>
#include <minmax.h>

using namespace std;

class rect
{
public:
	rect();
	rect(int xx, int yy, int ww, int hh);
	~rect();
	int intersect(rect r);
	int area() { return w * h; }
	int x, y, w, h;
private:
};

rect::rect()
{
	x = y = w = h = 0;
}

rect::rect(int xx, int yy, int ww, int hh)
{
	x = xx;
	y = yy;
	w = ww;
	h = hh;
}

rect::~rect()
{
}

//returns area of intersection
int rect::intersect(rect r)
{
	int iw = min(x + w, r.x + r.w) - max(x, r.x);
	int ih = min(y + h, r.y + r.h) - max(y, r.y);
	if (iw <= 0 || ih <= 0) return 0;
	return iw * ih;
}

int main()
{
	vector<rect> arr;
	int k, n, res, x = 0, y = 0;
	cin >> k >> n;
	res = k * k;
	arr.push_back(rect(0, 0, k, k));
	for (int nn = 0; nn < n; nn++)
	{
		char d;
		int a;
		rect newRect;
		cin >> d >> a;
		switch (d)
		{
		case 'N':
			newRect = rect(x, y + k, k, a);
			res += newRect.area();
			for (rect el : arr) res -= newRect.intersect(el);
			arr.push_back(newRect);
			y += a;
			break;
		case 'S':
			newRect = rect(x, y - a, k, a);
			res += newRect.area();
			for (rect el : arr) res -= newRect.intersect(el);
			arr.push_back(newRect);
			y -= a;
			break;
		case 'E':
			newRect = rect(x + k, y, a, k);
			res += newRect.area();
			for (rect el : arr) res -= newRect.intersect(el);
			arr.push_back(newRect);
			x += a;
			break;
		case 'W':
			newRect = rect(x - a, y, a, k);
			res += newRect.area();
			for (rect el : arr) res -= newRect.intersect(el);
			arr.push_back(newRect);
			x -= a;
			break;
		}
	}
	cout << res;
}
